//+------------------------------------------------------------------+
//|                                         WIEDSTONE_LockProfit.mq4 |
//|                                                        WIEDSTONE |
//|                                              wiedstone@yahoo.com |
//+------------------------------------------------------------------+
//Attach EA ini setelah Open Position, EA akan mengisi SL dan TP sesuai yang diinputkan 
//di parameter.
//Untuk hasil terbaik, maka apabila EA sudah diattach, ubahlah Time Frame menjadi M1 atau M5
//Feature tambahan:
//1. Level LockProfit mencapai 20 level
//2. Support untuk broker 4 maupun 5 Digits
//3. Support 'Stealth Mode' modo invisivel
#property copyright "WIEDSTONE"
#property link      "wiedstone@yahoo.com"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
//---- input parameters 
extern double    TP           = 100;
extern double    SL           = 50;
extern bool      StealthMode  = false;
extern int       LockProfit1  = 5;
extern int       LockProfit2  = 10;
extern int       LockProfit3  = 15;
extern int       LockProfit4  = 20;
extern int       LockProfit5  = 25;
extern int       LockProfit6  = 30;
extern int       LockProfit7  = 35;
extern int       LockProfit8  = 40;
extern int       LockProfit9  = 45;
extern int       LockProfit10 = 50;
       int       i, total;
       double    pt, existingsl, existingtp;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  pt=MarketInfo(Symbol(),MODE_POINT);
  int digits=MarketInfo(Symbol(),MODE_DIGITS);
  int JPY_pair=StringFind(Symbol(),"JPY",0);
  if(JPY_pair==-1){switch(digits)
                   { case 4:{pt=Point;return(pt);}
                     case 5:{pt=10*Point;return(pt);}
                   }
                  }
  if(JPY_pair==3){pt=0.01;return(pt);}
  //----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   total=OrdersTotal();
   existingsl=OrderStopLoss();
   existingtp=OrderTakeProfit();
   for(i=0; i<total; i++)
      {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if((existingsl==0) && (existingtp==0))
         {
          if(OrderType()==OP_BUY) {OrderModify(OrderTicket(), Ask,Ask-SL*pt, Ask+TP*pt, 0, CLR_NONE);}
          if(OrderType()==OP_SELL){OrderModify(OrderTicket(), Bid, Bid+SL*pt, Bid-TP*pt, 0, CLR_NONE);}     
         }  
      }
   Locking();
   return(0);
  }
//+------------------------------------------------------------------+
void Locking()
{
  //---- Variable
 int OPSell=0, OPBuy=0, OPtotal=0;
 int i;
 double harga;
 for(i= 0; i < OrdersTotal(); i++)
   { 
      if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES) == true)
      { 
         if (OrderSymbol() == Symbol()&& OrderCloseTime() == 0) 
         {
               harga = OrderOpenPrice();
               if(OrderType() == OP_BUY)  OPBuy++; 
               if(OrderType() == OP_SELL) OPSell++;
         } 
      } 
   }
   OPtotal = OPBuy + OPSell;
// End Variable Code
  if(OPtotal > 0)
  {
     double Pips_Buy            = Bid-OrderOpenPrice();
     double Pips_Sell           = OrderOpenPrice()-Ask;
     double Pips_Lock1          = LockProfit1 * pt;
     double Pips_Lock2          = LockProfit2 * pt;
     double Pips_Lock3          = LockProfit3 * pt;
     double Pips_Lock4          = LockProfit4 * pt;
     double Pips_Lock5          = LockProfit5 * pt;
     double Pips_Lock6          = LockProfit6 * pt;
     double Pips_Lock7          = LockProfit7 * pt;
     double Pips_Lock8          = LockProfit8 * pt;
     double Pips_Lock9          = LockProfit9 * pt;
     double Pips_Lock10         = LockProfit10 * pt;
     
     if(OPBuy > 0 && OPSell == 0)
       {
        if (Pips_Buy > Pips_Lock1 && Pips_Buy < Pips_Lock2)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock1,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock1 && Pips_Buy < Pips_Lock2) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock2 && Pips_Buy < Pips_Lock3)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock2,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock2 && Pips_Buy < Pips_Lock3) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock3 && Pips_Buy < Pips_Lock4)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock3,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock3 && Pips_Buy < Pips_Lock3) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock4 && Pips_Buy < Pips_Lock5)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock4,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock4 && Pips_Buy < Pips_Lock4) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock5 && Pips_Buy < Pips_Lock6)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock5,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock5 && Pips_Buy < Pips_Lock6) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock6 && Pips_Buy < Pips_Lock7)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock6,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock6 && Pips_Buy < Pips_Lock6) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock7 && Pips_Buy < Pips_Lock8)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock7,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock7 && Pips_Buy < Pips_Lock8) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock8 && Pips_Buy < Pips_Lock9)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock8,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock8 && Pips_Buy < Pips_Lock9) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock9 && Pips_Buy < Pips_Lock10)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock9,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock9 && Pips_Buy < Pips_Lock10) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock10)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock10,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock10) { close_all(); }
              }
        }
     }//if op buy>0
     
     if(OPBuy == 0 && OPSell > 0)
     {
        if (Pips_Sell > Pips_Lock1 && Pips_Sell < Pips_Lock2)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock1,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock1 && Pips_Sell < Pips_Lock2) { close_all(); }
              }
        }
        if (Pips_Sell > Pips_Lock2 && Pips_Sell < Pips_Lock3)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock2,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock2 && Pips_Buy < Pips_Sell) { close_all(); }
              }
        }
        if (Pips_Sell > Pips_Lock3 && Pips_Sell < Pips_Lock4)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock3,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock3 && Pips_Sell < Pips_Lock3) { close_all(); }
              }
        }
        if (Pips_Sell > Pips_Lock4 && Pips_Sell < Pips_Lock5)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock4,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock4 && Pips_Sell < Pips_Lock4) { close_all(); }
              }
        }
        if (Pips_Sell > Pips_Lock5 && Pips_Sell < Pips_Lock6)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock5,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock5 && Pips_Sell < Pips_Lock6) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock6 && Pips_Buy < Pips_Lock7)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock6,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock6 && Pips_Buy < Pips_Lock6) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock7 && Pips_Buy < Pips_Lock8)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock7,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock7 && Pips_Buy < Pips_Lock8) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock8 && Pips_Buy < Pips_Lock9)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock8,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock8 && Pips_Buy < Pips_Lock9) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock9 && Pips_Buy < Pips_Lock10)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock9,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock9 && Pips_Buy < Pips_Lock10) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock10)
        {   if(StealthMode==false){ OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock10,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock10) { close_all(); }
              }
        }
       }//if op sell>0
  }//if op total>0
}//void

void close_all()
{
    int total=OrdersTotal(), i;
    for(i=0; i<total; i++)
    {
        close();
    }
}

void close()
  {
    for(int cnt=OrdersTotal()-1; cnt>=0; cnt--)
    {
        if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
        {
           if(OrderType()==OP_SELL) {if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_ASK),3,CLR_NONE)) Print("last error code = ",GetLastError());}
           if(OrderType()==OP_BUY)  {if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_BID),3,CLR_NONE))  Print("last error code = ",GetLastError());}
        }
    }
  }